"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import typing
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor = ...

# `Endpoint` describes a network endpoint that serves a set of APIs.
# A service may expose any number of endpoints, and all endpoints share the
# same service configuration, such as quota configuration and monitoring
# configuration.
#
# Example service configuration:
#
#     name: library-example.googleapis.com
#     endpoints:
#       # Below entry makes 'google.example.library.v1.Library'
#       # API be served from endpoint address library-example.googleapis.com.
#       # It also allows HTTP OPTIONS calls to be passed to the backend, for
#       # it to decide whether the subsequent cross-origin request is
#       # allowed to proceed.
#     - name: library-example.googleapis.com
#       allow_cors: true
class Endpoint(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    NAME_FIELD_NUMBER: builtins.int
    ALIASES_FIELD_NUMBER: builtins.int
    FEATURES_FIELD_NUMBER: builtins.int
    TARGET_FIELD_NUMBER: builtins.int
    ALLOW_CORS_FIELD_NUMBER: builtins.int
    # The canonical name of this endpoint.
    name: typing.Text = ...
    # DEPRECATED: This field is no longer supported. Instead of using aliases,
    # please specify multiple [google.api.Endpoint][google.api.Endpoint] for each of the intended
    # aliases.
    #
    # Additional names that this endpoint will be hosted on.
    @property
    def aliases(
        self,
    ) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[
        typing.Text
    ]: ...
    # The list of features enabled on this endpoint.
    @property
    def features(
        self,
    ) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[
        typing.Text
    ]: ...
    # The specification of an Internet routable address of API frontend that will
    # handle requests to this [API Endpoint](https://cloud.google.com/apis/design/glossary).
    # It should be either a valid IPv4 address or a fully-qualified domain name.
    # For example, "8.8.8.8" or "myservice.appspot.com".
    target: typing.Text = ...
    # Allowing
    # [CORS](https://en.wikipedia.org/wiki/Cross-origin_resource_sharing), aka
    # cross-domain traffic, would allow the backends served from this endpoint to
    # receive and respond to HTTP OPTIONS requests. The response will be used by
    # the browser to determine whether the subsequent cross-origin request is
    # allowed to proceed.
    allow_cors: builtins.bool = ...
    def __init__(
        self,
        *,
        name: typing.Text = ...,
        aliases: typing.Optional[typing.Iterable[typing.Text]] = ...,
        features: typing.Optional[typing.Iterable[typing.Text]] = ...,
        target: typing.Text = ...,
        allow_cors: builtins.bool = ...,
    ) -> None: ...
    def ClearField(
        self,
        field_name: typing_extensions.Literal[
            "aliases",
            b"aliases",
            "allow_cors",
            b"allow_cors",
            "features",
            b"features",
            "name",
            b"name",
            "target",
            b"target",
        ],
    ) -> None: ...

global___Endpoint = Endpoint
